/***************************************************************************
                          util.h  -  description
                             -------------------
    begin                : Wed Nov 1 2000
    copyright            : (C) 2000 by Jon Anderson
    email                : janderson@onelink.com
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef UTIL_H
#define UTIL_H

#include <vector>
#include <stdio.h>
#include <iostream>
#include <stdlib.h>
#include <math.h>
#include <qimage.h>

using namespace std;

/**Utility namespace for encapsulating various unrelated utility methods.
  *@author Jon Anderson
  */
class Object;

namespace Util {

	void convertToArray( vector<int> &, int *narray );	
	void convertToVector( int *narray, int n, vector<int> &v );
	void dump( vector<int> & );
	void removeDuplicates(vector<int> &);
	void dump( Object * );
	
	QImage * loadImage();
   void saveImage( QImage * );

	
	#if defined( _GLUVOID )
  	typedef void (*gluCallback)(void);
	#else
  	typedef void (*gluCallback)(...);
	#endif
	

};

#endif
